#ifndef TXMLKEY_H
#define TXMLKEY_H

#include "TXmlEngine.h"
#include "TKey.h"

class TXmlFile;

class TXmlKey : public TKey {
   public:
      TXmlKey();
      
      TXmlKey(TXmlFile* file, TObject* obj, const char* name = 0);
      TXmlKey(TXmlFile* file, void* obj, TClass* objClass, const char* name);
      TXmlKey(TXmlFile* file, xmlNodePointer keynode);


      // redefined TKey Methods
      virtual void      Browse(TBrowser *) {}
      virtual void      Delete(Option_t *option="");
      virtual void      DeleteBuffer() {}
      virtual void      FillBuffer(char *&) {}
      virtual char     *GetBuffer() const { return 0; }
      virtual Long64_t  GetSeekKey() const  {return 0; }
      virtual Long64_t  GetSeekPdir() const {return 0;}
      virtual ULong_t   Hash() const { return 0; }  //????????????
      virtual void      Keep() {}
      virtual void      ls(Option_t* ="") const {}
      virtual void      Print(Option_t* ="") const {}
      
      virtual Int_t     Read(TObject*) { return 0; } // ?????????????
      virtual TObject  *ReadObj() { return 0; }      // ?????????????
      virtual void      ReadBuffer(char *&) {}
      virtual void      ReadFile() {}
      virtual void      SetBuffer() { fBuffer = 0; }
      virtual void      SetParent(TObject* ) { }
      virtual Int_t     Sizeof() const { return 0; } // ???????????????
      virtual Int_t     WriteFile(Int_t =1) { return 0; }


      // TXML xpecific methods            

      virtual ~TXmlKey();
      
      xmlNodePointer KeyNode() const { return fKeyNode; }
      
      TObject* GetObject();
      void* GetObjectAny();
      
   protected:
      virtual Int_t  Read(const char *name) { return TKey::Read(name); }
      void StoreObject(TXmlFile* file, void* obj, TClass* objClass);
      xmlNodePointer ObjNode();
   
      TXmlFile* fFile;          //!
      xmlNodePointer fKeyNode;  //!
      
   ClassDef(TXmlKey,1);
};




#endif
